'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _containersReducer = require('./containersReducer');

var _constants = require('./constants');

var _parentReduxShape = require('./parentReduxShape');

var _parentReduxShape2 = _interopRequireDefault(_parentReduxShape);

var _createLocalDispatch = require('./utils/createLocalDispatch');

var _createLocalDispatch2 = _interopRequireDefault(_createLocalDispatch);

var _reduceChildren = require('./utils/reduceChildren');

var _reduceChildren2 = _interopRequireDefault(_reduceChildren);

var _createRegisterChildReducer = require('./utils/createRegisterChildReducer');

var _createRegisterChildReducer2 = _interopRequireDefault(_createRegisterChildReducer);

var _createUnregisterChildReducer = require('./utils/createUnregisterChildReducer');

var _createUnregisterChildReducer2 = _interopRequireDefault(_createUnregisterChildReducer);

var _createGetChildState = require('./utils/createGetChildState');

var _createGetChildState2 = _interopRequireDefault(_createGetChildState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RootContainer = function (_React$Component) {
	_inherits(RootContainer, _React$Component);

	function RootContainer(props, context) {
		_classCallCheck(this, RootContainer);

		// Get the Redux store's (global) dispatch method.
		// This is passed in by react-redux mapDispatchToProps

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RootContainer).call(this, props, context));

		_this.localReduce = function (state, action) {
			var childReducers = _this.childReducers;

			var reducedChildren = (0, _reduceChildren2.default)(state, childReducers, action);

			if (_this.state.children !== reducedChildren) {
				_this.setState({ children: reducedChildren });
			}

			return reducedChildren;
		};

		var dispatch = props.dispatch; //

		var getGlobalState = function getGlobalState() {
			return _this.props.reduxState;
		};

		_this.state = {};

		_this.fullKey = _constants.LOCAL_REDUX;
		_this.childReducers = {};
		_this.dispatch = (0, _createLocalDispatch2.default)(_this.fullKey, dispatch);
		_this.getState = function () {
			return getGlobalState();
		};
		_this.getState.global = getGlobalState;
		_this.registerChildReducer = (0, _createRegisterChildReducer2.default)(_this);
		_this.unregisterChildReducer = (0, _createUnregisterChildReducer2.default)(_this);
		_this.getChildState = (0, _createGetChildState2.default)(_this);

		var requiresLocalReduce = true;
		_this.onChildMountChanged = function () {
			if (requiresLocalReduce) {
				requiresLocalReduce = false;
				setTimeout(function () {
					requiresLocalReduce = true;
					// Action type is bogus. It is just triggering a new
					// hit on the reducers, to update redux with the new
					// state of the children.
					dispatch({ type: '@@LOCAL_REDUX_CHILDCONTAINERS_MOUNT' });
				}, 0);
			}
		};
		return _this;
	}

	_createClass(RootContainer, [{
		key: 'getChildContext',
		value: function getChildContext() {
			return {
				parentRedux: this
			};
		}
	}, {
		key: 'componentWillMount',
		value: function componentWillMount() {
			(0, _containersReducer.registerRootReducer)(this.localReduce);

			// Action type is bogus. It is just triggering a new
			// hit on the reducers, to get the initial state for this root.
			// TODO: maybe need to integrate with onChildMountChanged (to only have
			// one reduce-hit). Or get the initial state from 'global state' (but what
			// is the key in the state graph (the root reducer knows)? maybe
			// rootcontainer needs a required prop 'stateKey')
			var dispatch = this.props.dispatch;

			dispatch({ type: '@@LOCAL_REDUX_ROOTCONTAINER_MOUNT' });
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			(0, _containersReducer.unregisterRootReducer)(this.localReduce);
		}
	}, {
		key: 'shouldComponentUpdate',
		value: function shouldComponentUpdate(nextProps, nextState) {
			if (nextState.children !== this.state.children) {
				return true;
			}

			// Accomodate for properties that come in (e.g. a higher-order connect() of Redux)
			var props = this.props;

			return Object.keys(nextProps).some(function (key) {
				return nextProps[key] !== props[key];
			});
		}
	}, {
		key: 'render',
		value: function render() {
			// If not been reduced yet, wait for it.
			if (!this.state.children) {
				return null;
			}
			return _react.Children.only(this.props.children);
		}
	}]);

	return RootContainer;
}(_react2.default.Component);

RootContainer.childContextTypes = {
	parentRedux: _parentReduxShape2.default.isRequired
};
RootContainer.propTypes = {
	dispatch: _react.PropTypes.func.isRequired,
	children: _react.PropTypes.element.isRequired
};
exports.default = (0, _reactRedux.connect)(function (state) {
	return { reduxState: state };
})(RootContainer);