'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _parentReduxShape = require('./parentReduxShape');

var _parentReduxShape2 = _interopRequireDefault(_parentReduxShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function () {
	for (var _len = arguments.length, middlewares = Array(_len), _key = 0; _key < _len; _key++) {
		middlewares[_key] = arguments[_key];
	}

	var createDispatch = function createDispatch(parentRedux) {
		var middlewareAPI = {
			dispatch: parentRedux.dispatch,
			getState: parentRedux.getState
		};

		var chain = middlewares.map(function (middleware) {
			return middleware(middlewareAPI);
		});
		var finalDispatch = _redux.compose.apply(undefined, _toConsumableArray(chain))(parentRedux.dispatch);
		finalDispatch.global = parentRedux.dispatch.global;
		return finalDispatch;
	};

	return function (createContainer) {
		return function (reducer, mapStateToProps) {
			return function (View) {
				var _class, _temp;

				return createContainer(reducer, mapStateToProps)((_temp = _class = function (_Component) {
					_inherits(ViewWithMiddleware, _Component);

					_createClass(ViewWithMiddleware, [{
						key: 'getChildContext',
						value: function getChildContext() {
							return {
								parentRedux: this.parentRedux
							};
						}
					}]);

					function ViewWithMiddleware(props, context) {
						_classCallCheck(this, ViewWithMiddleware);

						var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ViewWithMiddleware).call(this, props, context));

						var originalParentRedux = context.parentRedux;


						_this.parentRedux = _extends({}, originalParentRedux, {
							dispatch: createDispatch(originalParentRedux)
						});
						return _this;
					}

					_createClass(ViewWithMiddleware, [{
						key: 'render',
						value: function render() {
							var dispatch = this.parentRedux.dispatch;

							return _react2.default.createElement(View, _extends({}, this.props, { dispatch: dispatch }));
						}
					}]);

					return ViewWithMiddleware;
				}(_react.Component), _class.contextTypes = {
					parentRedux: _parentReduxShape2.default.isRequired
				}, _class.childContextTypes = {
					parentRedux: _parentReduxShape2.default.isRequired
				}, _temp));
			};
		};
	};
};