'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _redux = require('redux');

var _react = require('react');

var _constants = require('./constants');

var _parentReduxShape = require('./parentReduxShape');

var _parentReduxShape2 = _interopRequireDefault(_parentReduxShape);

var _createLocalDispatch = require('./utils/createLocalDispatch');

var _createLocalDispatch2 = _interopRequireDefault(_createLocalDispatch);

var _reduceChildren = require('./utils/reduceChildren');

var _reduceChildren2 = _interopRequireDefault(_reduceChildren);

var _createRegisterChildReducer = require('./utils/createRegisterChildReducer');

var _createRegisterChildReducer2 = _interopRequireDefault(_createRegisterChildReducer);

var _createUnregisterChildReducer = require('./utils/createUnregisterChildReducer');

var _createUnregisterChildReducer2 = _interopRequireDefault(_createUnregisterChildReducer);

var _createGetChildState = require('./utils/createGetChildState');

var _createGetChildState2 = _interopRequireDefault(_createGetChildState);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var noChildren = {};

exports.default = function (reducer, mapStateToProps, mapDispatchToProps) {
	// , mapDispatchToProps

	mapStateToProps = mapStateToProps || function () {
		return null;
	};

	var finalMapDispatchToProps = typeof mapDispatchToProps === 'function' ? mapDispatchToProps // it is a function -> use as is
	: !mapDispatchToProps ? function (dispatch) {
		return { dispatch: dispatch };
	} // no mapDispatchToProps specified, use the default
	: function (dispatch) {
		return (0, _redux.bindActionCreators)(mapDispatchToProps, dispatch);
	}; // it is an object, bind it to dispatch.

	var initialReducerState = reducer(undefined, { type: _constants.LOCAL_REDUX + 'DETERMINE_ININITAL_STATE' });

	return function (View) {
		var _class, _temp;

		return _temp = _class = function (_Component) {
			_inherits(HocView, _Component);

			_createClass(HocView, [{
				key: 'getChildContext',
				value: function getChildContext() {
					return {
						parentRedux: this
					};
				}
			}]);

			function HocView(props, context) {
				_classCallCheck(this, HocView);

				// todo: how to get the display name (maybe in options).

				var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(HocView).call(this, props, context));

				_this.localReduce = function () {
					var state = arguments.length <= 0 || arguments[0] === undefined ? { local: initialReducerState } : arguments[0];
					var action = arguments[1];


					// this.reduced = true

					var fullKey = _this.fullKey;
					var childReducers = _this.childReducers;
					var _state = state;
					var local = _state.local;
					var children = _state.children;
					var type = action.type;

					var isLocalAction = type && type.indexOf(_constants.LOCAL_REDUX) === 0;
					var isActionForSubtree = !isLocalAction || type.indexOf(fullKey) === 0;
					var isActionForReducer = !isLocalAction || !isActionForSubtree || type.indexOf('->', fullKey.length) === -1; // is local type containing an action-type for this reducer?

					(0, _warning2.default)(isLocalAction && isActionForSubtree && isActionForReducer && action.globalType, 'An action is being dispatched which has a property \'globalType\'. This is a reserved key for a local-react-redux container and will be overwritten.');

					// Check if this action is intended for this container (the additional information
					// has been added by the RootContainer).
					var localAction = isLocalAction && isActionForSubtree && isActionForReducer ? _extends({}, action, { type: type.substr(fullKey.length), globalType: type }) : action;

					// Ask the reducer to reduce
					var newLocalState = !isLocalAction || isActionForSubtree && isActionForReducer ? reducer(local, localAction) : local;

					// Update the state, if changed. To accomodate for immutability.
					if (local !== newLocalState) {
						state = _extends({}, state, {
							local: newLocalState
						});
					}

					// Reduce all the registered children.

					// Make sure to only use child-state of children that are still alive.
					var finalChildrenState = removeUnmountedChildState(children, _this.childReducers);

					var newChildrenState = !isLocalAction || isActionForSubtree ? (0, _reduceChildren2.default)(finalChildrenState || noChildren, _this.childReducers, action) : children;
					// Update the state, if changed. To accomodate for immutability.
					if (newChildrenState !== children) {
						state = _extends({}, state, {
							children: newChildrenState
						});
					}

					// local and children state is finialized. If anything changed, we need to
					// update UI.
					if (_this.state.local !== state.local || _this.state.children !== state.children) {
						_this.setState(state);
					}

					return state;
				};

				if (!props.localKey) {
					throw new Error('View \'' + View.displayName + '\' is missing the required localKey prop.');
				}

				var parentRedux = context.parentRedux;


				_this.localKey = props.localKey;
				_this.childReducers = {};
				// Ask the parent for the initial state
				_this.state = _extends({
					// children: {},
					local: initialReducerState
				}, parentRedux.getChildState(_this.localKey)); //  { container: { local: initialReducerState, children: {} } }

				// parentReduxShape interface
				_this.fullKey = parentRedux.fullKey + _this.localKey + '->';
				_this.getState = function () {
					return _this.state.local;
				};
				_this.getState.global = parentRedux.getState.global;
				_this.dispatch = (0, _createLocalDispatch2.default)(_this.fullKey, parentRedux.dispatch.global);
				_this.registerChildReducer = (0, _createRegisterChildReducer2.default)(_this);
				_this.unregisterChildReducer = (0, _createUnregisterChildReducer2.default)(_this);
				_this.onChildMountChanged = parentRedux.onChildMountChanged;
				_this.getChildState = (0, _createGetChildState2.default)(_this);
				return _this;
			}

			_createClass(HocView, [{
				key: 'componentWillMount',
				value: function componentWillMount() {
					var fullKey = this.fullKey;
					var parentRedux = this.context.parentRedux;

					parentRedux.registerChildReducer(this.localKey, this.localReduce);

					// Notify the RootContainer that a new child-container is about to be added.
					// This is required to be able to reduce the complete local state again (with
					// this new addition).
					this.onChildMountChanged();
				}
			}, {
				key: 'componentWillUnmount',
				value: function componentWillUnmount() {
					var parentRedux = this.context.parentRedux;

					parentRedux.unregisterChildReducer(this.localKey, this.localReduce);

					// Notify the RootContainer that a new child-container is about to be removed.
					// This is required to be able to reduce the complete local state again (with)
					// this removal).
					this.localReduce = function () {
						return null;
					};
					this.onChildMountChanged(); // TODO: name should be 'unmount'
				}
			}, {
				key: 'render',
				value: function render() {
					var parentRedux = this.context.parentRedux;
					var dispatch = this.dispatch;
					var props = this.props;

					// TODO: review comment
					// If the render() method is hit the first time, the localReduce() method will not
					// have been executed yet (that happens in the onChildMountChanged() of the
					// RootContainer, but that method waits until all children have been mounted -- to
					// optimize the amount of localReduce calls in the complete tree)
					//
					// But, we know the state is such a case: it is the reducer's initial state.

					var localState = this.getState();

					return (0, _react.createElement)(View, _extends({}, mapStateToProps(localState, props), finalMapDispatchToProps(dispatch, props), props));
				}
			}, {
				key: 'shouldComponentUpdate',
				value: function shouldComponentUpdate(nextProps, nextState) {
					// Only local state is important (child-containers will handle their own update-logic -- same method of course)
					if (nextState.local !== this.state.local) {
						return true;
					}
					// Accomodate for properties that come in (e.g. a higher-order connect() of Redux)
					var props = this.props;

					return Object.keys(nextProps).some(function (key) {
						return nextProps[key] !== props[key];
					});
				}
			}]);

			return HocView;
		}(_react.Component), _class.contextTypes = {
			parentRedux: _parentReduxShape2.default.isRequired
		}, _class.childContextTypes = {
			parentRedux: _parentReduxShape2.default.isRequired
		}, _temp;
	};
};

var removeUnmountedChildState = function removeUnmountedChildState(children, childReducers) {
	if (!children) {
		return children;
	}

	var isDifferent = false;

	var updatedChildren = Object.keys(children).reduce(function (state, childkey) {
		if (childReducers[childkey]) {
			state[childkey] = children[childkey];
		} else {
			isDifferent = true;
		}
		return state;
	}, {});

	return isDifferent ? updatedChildren : children;
};