'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
var rootReducer = null;

// TODO: find a way to be able to register a root-container, instead of having only one.

/**
 * The redux reducer that handles all container states.
 */

exports.default = function () {
	var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
	var action = arguments[1];

	if (rootReducer) {
		return rootReducer(state, action);
	}
	return state;
};

var registerRootReducer = exports.registerRootReducer = function registerRootReducer(reducer) {
	if (rootReducer) {
		throw new Error('There can only be one <RootContainer>.');
	}
	rootReducer = reducer;
};

var unregisterRootReducer = exports.unregisterRootReducer = function unregisterRootReducer(reducer) {
	if (rootReducer !== reducer) {
		throw new Error('Cannot unregister the root reducer becaue it is not the currently registered root reducer.');
	}
	rootReducer = null;
};