'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (typePrefix, dispatch) {

	var localDispatch = function localDispatch(action) {

		if (!(0, _isPlainObject2.default)(action)) {
			throw new Error('Actions must be plain objects. Use custom middleware for async actions.');
		}
		if (typeof action.type === 'undefined') {
			throw new Error('Actions may not have an undefined "type" property. Have you misspelled a constant?');
		}

		return dispatch(_extends({}, action, {
			type: typePrefix + action.type
		}));
	};

	// Enable access to the global dispatch.
	localDispatch.global = dispatch;
	return localDispatch;
};