"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (container) {
	return function (childKey, childReducer) {
		if (container.childReducers[childKey] !== childReducer) {
			throw new Error("Cannot unregister the given child reducer. The child key '" + childKey + "' does not match the provided child reducer.");
		}
		delete container.childReducers[childKey];
	};
};